<template>
  <v-autocomplete required outlined hide-details v-if="ingredientList" v-model="ingredient" :items="ingredientList" item-text="Label" label="Ingredient" :search-input.sync="searchString" return-object class="mx-2" />
</template>

<script lang="ts">
import VueWithMixins from "../../../assets/VueWithMixins";
import Component from "vue-class-component";
import { Watch } from "vue-property-decorator";
import Ingredient from "../../../transport/Ingredient";
import IngredientService from "../../../services/IngredientService";

@Component
export default class IngredientSelect extends VueWithMixins {
  private ingredientService: IngredientService = null;
  private ingredientList: Ingredient[] = [];

  private searchString: string = "";
  private ingredient: Ingredient = null;

  mounted() {
    this.ingredientService = new IngredientService();

    this.searchIngredients(this.searchString);
  }

  @Watch("searchString")
  onSearchStringChange(searchString: string) {
    if (searchString !== null) this.searchIngredients(searchString);
  }
  @Watch("ingredient")
  onIngredientChange() {
    this.$emit("on-change", this.ingredient);
  }
  private searchIngredients(strToSearch: string) {
    this.ingredientService.searchIngredients(strToSearch, 9).then(res => {
      this.ingredientList = res;
    });
  }
}
</script>
